uab = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceModuleCore-2.0")
uab:SetModuleMixins("AceDebug-2.0", "AceEvent-2.0", "AceModuleCore-2.0")

uab:RegisterDB("UABDB")

function uab.modulePrototype:OnInitialize()
	if not self.db then
		self.core:RegisterDefaults(self.name, "profile", self.defaultDB or {})
		self.db = self.core:AcquireDBNamespace(self.name)
	end

    self:SetDebugging(self.db.profile.debugging)
    self.core.options.args.debug.args[self.name] = {
        type = 'toggle',
        name = self.name,
        desc = "Enable debugging for the "..self.name.." module",
        get = function()
            return self:IsDebugging()
        end,
        set = function(v)
            self.db.profile.debugging = v
            self:SetDebugging(self.db.profile.debugging)
        end,
    }
end

function uab.modulePrototype:OnEnable()
end

function uab.modulePrototype:SetFrameAttribute(frame, attrib, val, state)
    uab.SetFrameAttributeDebug(self, frame, attrib, val, state)
end

function uab.modulePrototype:SetUnknownFrameAttribute(frame, attrib, val, state)
    uab.SetUnknownFrameAttributeDebug(self, frame, attrib, val, state)
end

function uab.modulePrototype:SetBoolFrameAttribute(frame, attrib, val, state)
    uab.SetBoolFrameAttributeDebug(self, frame, attrib, val, state)
end

function uab.modulePrototype:SetFrameFrameAttribute(frame, attrib, val, state)
    uab.SetFrameFrameAttributeDebug(self, frame, attrib, val, state)
end

uab.hasIcon = "Interface\\CURSOR\\\Cast"
uab.defaultPosition = "RIGHT"
uab.hideWithoutStandby = true
uab.independentProfile = true
uab.hasNoColor = true
uab.cannotDetachTooltip = true

uab.constants = {}
uab.classes = {}
uab.interfaces = {}
uab.mixins = {}
uab.namespace = {}
uab.namespace.modules = {}

uab.constants.buttonWidth = 38
uab.constants.buttonHeight = 38
uab.constants.controlsperunit = 3
uab.constants.groupInfo = {
	player = { name = "player", unitcount = 1, displayName = "Player", minstate = 100, maxstate = 199 },
	pet = { name = "pet", unitcount = 1, displayName = "Pet", minstate = 200, maxstate = 299 },
	target = { name = "target", unitcount = 1, displayName = "Target", minstate = 300, maxstate = 399 },
	targettarget = { name = "targettarget", unitcount = 1, displayName = "Target of Target", minstate = 400, maxstate = 499 },
	targettargettarget = { name = "targettargettarget", unitcount = 1, displayName = "ToT Target", minstate = 500, maxstate = 599 },
	focus = { name = "focus", unitcount = 1, displayName = "Focus", minstate = 600, maxstate = 599 },
	focustarget = { name = "focustarget", unitcount = 1, displayName = "Focus Target", minstate = 700, maxstate = 799 },
	partyraid = { name = "partyraid", unitcount = 60, displayName = "Party/Raid", minstate = 1001, maxstate = 2000 },
}
uab.constants.maxactivatorcontrols = 3000

uab.constants.grow = {}
uab.constants.grow.up = "u"
uab.constants.grow.down = "d"
uab.constants.grow.left = "l"
uab.constants.grow.right = "r"

uab.constants.placement = {}
uab.constants.placement.left = "l"
uab.constants.placement.topleft = "tl"
uab.constants.placement.top = "t"
uab.constants.placement.topright = "tr"
uab.constants.placement.right = "r"
uab.constants.placement.bottomright = "br"
uab.constants.placement.bottom = "b"
uab.constants.placement.bottomleft = "bl"

uab.constants.anchor = {}
uab.constants.anchor.top = "top"
uab.constants.anchor.left = "left"

function uab.constants.AnchorDisplayValue(value)
    if value == uab.constants.anchor.top then
        return "Top & Bottom"
    else
        return "Left & Right"
    end
end

function uab.constants.PlacementDisplayValue(value)
    if value == uab.constants.placement.top then
        return "Top"
    elseif value == uab.constants.placement.topright then
        return "Top Right"
    elseif value == uab.constants.placement.topleft then
        return "Top Left"
    elseif value == uab.constants.placement.bottom then
        return "Bottom"
    elseif value == uab.constants.placement.bottomright then
        return "Bottom Right"
    elseif value == uab.constants.placement.bottomleft then
        return "Bottom Left"
    elseif value == uab.constants.placement.left then
        return "Left"
    else
        return "Right"
    end
end

function uab.constants.GrowDirectionDisplayValue(value)
    if value == uab.constants.grow.up then
        return "Up"
    elseif value == uab.constants.grow.down then
        return "Down"
    elseif value == uab.constants.grow.left then
        return "Left"
    else
        return "Right"
    end
end

UABDebug = {}

uab.mixins.aceDB = AceLibrary("AceDB-2.0")
uab.mixins.aceEvent = AceLibrary("AceEvent-2.0")
uab.mixins.aceOO = AceLibrary("AceOO-2.0")
uab.mixins.aura = AceLibrary("SpecialEvents-Aura-2.0")
uab.mixins.banzai = AceLibrary("Banzai-1.1")
uab.mixins.tablet = AceLibrary("Tablet-2.0")

uab.interfaces.IUnitEffect = uab.mixins.aceOO.Interface {
	GetName = "function",
	GetDisplayName = "function",
	GetDefaultHighlightColor = "function",
    IsActive = "function",
}

uab.interfaces.IActionData = uab.mixins.aceOO.Interface {
    IsUsable = "function",
	GetAttributes = "function",
	GetClassName = "function",
	GetIcon = "function",
	GetText = "function",
    GetCount = "function",
    GetCooldown = "function",
	SetTooltip = "function",
}

uab.interfaces.IActionSetLayout = uab.mixins.aceOO.Interface {
	ArrangeButtons = "function",
	GetConfig = "function",
	SetSettings = "function",
}

uab.interfaces.IActionSetLayoutConfig = uab.mixins.aceOO.Interface {
	SettingsChanged = "function", -- SettingsChanged(settings) or SettingsChanged()
	UseDefaults = "function", -- UseDefaults()
	MenuOptionArgs = "function", -- MenuOptionArgs()
}

uab.interfaces.IActionSetLayoutManager = uab.mixins.aceOO.Interface {
	GetLayout = "function",
	GetName = "function",
	GetDisplayName = "function",
}
		 		 
uab.layoutManagers = {}
uab.unitEffectClasses = {}
uab.unitEffectClassInstances = {}

function uab.print(msg)
    if msg then DEFAULT_CHAT_FRAME:AddMessage(msg) end
end

function uab.SetFrameAttribute(frame, attrib, val, state)
    uab.SetFrameAttributeDebug(uab, frame, attrib, val, state)
end

function uab.SetUnknownFrameAttribute(frame, attrib, val, state)
    uab.SetUnknownFrameAttributeDebug(uab, frame, attrib, val, state)
end

function uab.SetBoolFrameAttribute(frame, attrib, val, state)
    uab.SetBoolFrameAttributeDebug(uab, frame, attrib, val, state)
end

function uab.SetFrameFrameAttribute(frame, attrib, val, state)
    uab.SetFrameFrameAttributeDebug(uab, frame, attrib, val, state)
end

function uab.SetFrameAttributeDebug(dbgobj, frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
end

function uab.SetUnknownFrameAttributeDebug(dbgobj, frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
end

function uab.SetBoolFrameAttributeDebug(dbgobj, frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
end

function uab.SetFrameFrameAttributeDebug(dbgobj, frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
end

--[[
Default profile configuration settings
--]]
uab.profileDefaults = {
    tooltips = true,
    directcast = true,
    fastchangeunit = true,
    checkusable = true,
    blinkcycle = 1.0,
    borderwidth = 2,
    alpha = 0.5,
    activators = {
    },
    groupstayopen = {
    },
    independent = {
    },
    framegroups = {
    },
    scale = {
        player = {
			usedefault = true,
		},
        pet = {
			usedefault = true,
		},
        partyraid = {
			usedefault = true,
		},
        focus = {
			usedefault = true,
		},
        focustarget = {
			usedefault = true,
		},
        target = {
			usedefault = true,
		},
        targettarget = {
			usedefault = true,
		},
        targettargettarget = {
			usedefault = true,
		},
        default = {
			value = 1.0,
		},
    },
    position = {
        player = {
			usedefault = true,
		},
        pet = {
			usedefault = true,
		},
        partyraid = {
			usedefault = true,
		},
        focus = {
			usedefault = true,
		},
        focustarget = {
			usedefault = true,
		},
        target = {
			usedefault = true,
		},
        targettarget = {
			usedefault = true,
		},
        targettargettarget = {
			usedefault = true,
		},
        default = {
			point = "CENTER",
            relpoint = "cursor",
            x = 0.0,
            y = 0.0,
		},
    },
    layout = "uab.Bar",
    layouts = {
    },
}

uab.classes.DefaultScaleAndAnchor = {}

function uab.classes.DefaultScaleAndAnchor:IsDefaultScale()
end

function uab.classes.DefaultScaleAndAnchor:IsDefaultPosition()
end

function uab.classes.DefaultScaleAndAnchor:UseDefaultScale()
end

function uab.classes.DefaultScaleAndAnchor:UseDefaultAnchor()
end

function uab.classes.DefaultScaleAndAnchor:GetScale()
    return uab.db.profile.scale.default.value
end

function uab.classes.DefaultScaleAndAnchor:SetScale(v)
    uab.db.profile.scale.default.value = v
end

function uab.classes.DefaultScaleAndAnchor:GetPoint()
    return uab.db.profile.position.default.point
end

function uab.classes.DefaultScaleAndAnchor:SetPoint(v)
    uab.db.profile.position.default.point = v
end

function uab.classes.DefaultScaleAndAnchor:GetRelPoint()
    return uab.db.profile.position.default.relpoint
end

function uab.classes.DefaultScaleAndAnchor:SetRelPoint(v)
    uab.db.profile.position.default.relpoint = v
end

function uab.classes.DefaultScaleAndAnchor:GetHorizontal()
    return uab.db.profile.position.default.x
end

function uab.classes.DefaultScaleAndAnchor:SetHorizontal(v)
    uab.db.profile.position.default.x = v
end

function uab.classes.DefaultScaleAndAnchor:GetVertical()
    return uab.db.profile.position.default.y
end

function uab.classes.DefaultScaleAndAnchor:SetVertical(v)
    uab.db.profile.position.default.y = v
end

function uab.ScaleAndAnchorOptions(obj)
    local args = {
        scale = {
            type = 'range',
            name = "Scale",
            desc = "Action button scale",
            disabled = function() return obj:IsDefaultScale() end,
            order = 120,
            min = 0.05,
            max = 2.00,
            step = 0.05,
            isPercent = true,
            get = function()
                return obj:GetScale()
            end,
            set = function(value)
                obj:SetScale(value)
                uab.main:ScaleChanged()
            end,
        },
        point = {
            type = 'text',
            name = "Point",
            usage = "<name>",
            desc = "Select the point on the cancel button that positioning in based from",
            disabled = function() return obj:IsDefaultPosition() end,
            order = 130,
            get = function()
                return obj:GetPoint()
            end,
            set = function(pt)
                obj:SetPoint(pt)
                uab.main:PositionChanged()
            end,
            validate = {
                "BOTTOM",
                "BOTTOMLEFT",
                "BOTTOMRIGHT",
                "CENTER",
                "LEFT",
                "RIGHT",
                "TOP",
                "TOPLEFT",
                "TOPRIGHT",
            },
        },
        relativepoint = {
            type = 'text',
            name = "Relative Point",
            usage = "<name>",
            desc = "Select the point the buttons are relative to",
            disabled = function() return obj:IsDefaultPosition() end,
            order = 140,
            get = function()
                return obj:GetRelPoint()
            end,
            set = function(pt)
                obj:SetRelPoint(pt)
                uab.main:PositionChanged()
            end,
            validate = {
                "cursor",
                "screen",
                "BOTTOM",
                "BOTTOMLEFT",
                "BOTTOMRIGHT",
                "CENTER",
                "LEFT",
                "RIGHT",
                "TOP",
                "TOPLEFT",
                "TOPRIGHT",
            },
        },
        horizontal = {
            type = 'text',
            name = "Horizontal",
            desc = "Horizontal offset (positive is right, negative is left, 0 is over cursor)",
            disabled = function() return obj:IsDefaultPosition() end,
            usage = "<number>",
            order = 150,
            get = function()
                return obj:GetHorizontal()
            end,
            set = function(value)
                obj:SetHorizontal(math.floor(tonumber(value)))
                uab.main:PositionChanged()
            end,
            validate = function(value)
                local v = math.floor(tonumber(value))
                if tostring(v) == value then
                    return true
                end
            end,
        },
        vertical = {
            type = 'text',
            name = "Vertical",
            desc = "Vertical offset (positive is up, negative is down, 0 is over cursor)",
            disabled = function() return obj:IsDefaultPosition() end,
            usage = "<number>",
            order = 160,
            get = function()
                return obj:GetVertical()
            end,
            set = function(value)
                obj:SetVertical(math.floor(tonumber(value)))
                uab.main:PositionChanged()
            end,
            validate = function(value)
                local v = math.floor(tonumber(value))
                if tostring(v) == value then
                    return true
                end
            end,
        },
    }

    local usedefaultscale = obj:UseDefaultScale()
    if usedefaultscale then
        args.usedefaultscale = usedefaultscale
        args.usedefaultscale.order = 100
    end
    
    local usedefaultanchor = obj:UseDefaultAnchor()
    if usedefaultanchor then
        args.usedefaultanchor = usedefaultanchor
        args.usedefaultanchor.order = 110
    end

    if usedefaultscale or usedefaultanchor then
        args.spacing3 = {
            type = 'header',
            name = " ",
            order = 115,
        }
    end

    return args
end

--[[
Constant menu/slash commands.
--]]
uab.options = {
    type = 'group',
    args = {
        actionsets = {
            type = 'group',
            name = "Action Sets",
            desc = "Create, modify, and remove action sets",
            disabled = function() return InCombatLockdown() end,
    		order = 10,
            args = {},
        },
        
        lookandfeel = {
            type = 'group',
            name = "Look and Feel",
            desc = "Options that affect how buttons appear.  Includes layout, positioning, scaling, and button behavior",
            disabled = function() return InCombatLockdown() end,
    		order = 20,
            args = {
                spacing2 = {
            		name = "Button Appearance",
            		type = 'header',
            		order = 22,
            	},

                defaultanchorscale = {
                    type = 'group',
                    name = "Default",
                    desc = "Default button positioning and layout",
            		order = 30,
                    args = uab.ScaleAndAnchorOptions(uab.classes.DefaultScaleAndAnchor)
                },
                                        
                groupanchorscale = {
                    type = 'group',
                    name = "Groups",
                    desc = "Anchor, scale, and behavior information for each unit group",
                    order = 40,
                    args  = {},
                },
                
                framegroups = {
                    type = 'group',
                    name = "Frame groups",
                    desc = "Frame groupings.  Enable/disable frames for UAB support, and define the anchor, scale, and behavior information for each frame group",
                    disabled = function() return InCombatLockdown() end,
            		order = 55,
                    args = {},
                },
                
                spacing3 = {
            		name = " ",
            		type = 'header',
            		order = 56,
            	},
            
                behaviorhdr = {
            		name = "Global Behavior",
            		type = 'header',
            		order = 57,
            	},

                directcast = {
                    type = 'toggle',
                    name = "Direct cast",
                    desc = "Use direct click-casting when action set contains a single action",
                    order = 60,
                    get = function()
                        return uab.db.profile.directcast
                    end,
                    set = function(v)
                        uab.db.profile.directcast = v
                        uab.main:DirectCastChanged()
                    end,
                },
                tooltip = {
                    type = 'toggle',
                    name = "Tooltips",
                    desc = "Show action tooltips",
            		order = 70,
                    get = function()
                        return uab.db.profile.tooltips
                    end,
                    set = function(v)
                        uab.db.profile.tooltips = v
                    end,
                },
                stayopen = {
                    type = 'toggle',
                    name = "Stay open",
                    desc = "Keep actions displayed after use.  Clicking cancel closes actions",
            		order = 80,
                    get = function()
                        return uab.db.profile.stayopen
                    end,
                    set = function(v)
                        uab.db.profile.stayopen = v
                        uab.main:StayOpenChanged()
                    end,
                },
                fastchangeunit = {
                    type = 'toggle',
                    name = "Fast change unit",
                    desc = "When selected, clicking on a different unit frame when action buttons are already shown will immediately reposition the buttons to the new unit frame and associate any action with that unit.  When not selected, clicking a new unit frame closes the action buttons",
            		order = 90,
                    get = function()
                        return uab.db.profile.fastchangeunit
                    end,
                    set = function(v)
                        uab.db.profile.fastchangeunit = v
                        uab.main:FastChangeUnitChanged()
                    end,
                },
            }
    	},
    
        unitstatus = {
            type = 'group',
            name = "Unit Status",
            desc = "Unit status settings",
            disabled = function() return InCombatLockdown() end,
    		order = 40,
            args = {},
    	},

        settings = {
            type = 'group',
            name = "Settings",
            desc = "Button indicator settings",
            disabled = function() return InCombatLockdown() end,
            order = 50,
            args = {
                highlight = {
                    type = 'range',
                    name = "Highlight Width",
                    desc = "Width of the highlight border, when active.",
                    order = 10,
                    min = 1,
                    max = 5,
                    step = 1,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.borderwidth
                    end,
                    set = function(value)
                        uab.db.profile.borderwidth = value
                        uab.main:HighlightBorderChanged()
                    end,
                },
                blinkrate = {
                    type = 'range',
                    name = "Blink Rate",
                    desc = "The rate at which the action button blinks.  This is the complete cycle time from visible back to visible.",
                    order = 20,
                    min = 0.1,
                    max = 2.0,
                    step = 0.1,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.blinkcycle
                    end,
                    set = function(value)
                        uab.db.profile.blinkcycle = value
                    end,
                },
                lowalpha = {
                    type = 'range',
                    name = "Low alpha",
                    desc = "The alpha value to use when displaying a button with low alpha.",
                    order = 30,
                    min = 0.05,
                    max = 1.0,
                    step = 0.05,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.alpha
                    end,
                    set = function(value)
                        uab.db.profile.alpha = value
                    end,
                },
                checkusable = {
                    type = 'toggle',
                    name = "Check Usable",
                    desc = "When checked, examine whether an action is usable, and if not usable, show as unusable in addition to other action button indicators.",
                    order = 40,
                    get = function()
                        return uab.db.profile.checkusable
                    end,
                    set = function(value)
                        uab.db.profile.checkusable = value
                    end,
                },
            },
        },
        
        debug = {
            type = 'group',
            name = "Debug",
            desc = "Enable debug messages for UAB modules",
            disabled = function() return InCombatLockdown() end,
            order = 60,
            args = {},
        },
        
        dump = {
            type = 'execute',
            name = "Dump",
            desc = "Dump the current state of the uab activators, unit groups, controls, and action buttons",
            order = 70,
            func = function()
                uab.main:Dump()
            end,
        },
    },
}

function uab.DropDownSelect(frame, functionData)
    frame[functionData.func](frame, this, functionData.arg1, functionData.arg2, functionData.arg3)
end

function uab.GroupIterate(fcn, self, context)
    local key, val
    for key, val in pairs(uab.constants.groupInfo) do
        local result = fcn and fcn(self, context, key, val)
        if result then
            return result
        end
    end
end

function uab:OnInitialize()
    self:RegisterDefaults('profile', self.profileDefaults)

    -- Clear debug message table
    UABDebug = {}

    self:SetupOffsetOptions()
    
	self.main = self:GetModule("Main")

    self:SetDebugging(self.db.profile.debugging)
    
    self.options.args.debug.args.UnitActionBars = {
        type = 'toggle',
        name = "UnitActionBars",
        desc = "Enable debugging for the UnitActionBars module",
        get = function()
            return self:IsDebugging()
        end,
        set = function(v)
            self.db.profile.debugging = v
            self:SetDebugging(self.db.profile.debugging)
        end,
    }
    
    self:RegisterChatCommand({ "/unitactionbars", "/uab" }, self.options)
	self.OnMenuRequest = self.options
end

uab.classes.GroupScaleAndAnchor = uab.mixins.aceOO.Class()

function uab.classes.GroupScaleAndAnchor.prototype:init(groupname)
    uab.classes.GroupScaleAndAnchor.super.prototype.init(self)
    self.groupname = groupname
end

function uab.classes.GroupScaleAndAnchor.prototype:SetGroup(groupname)
    self.groupname = groupname
end

function uab.classes.GroupScaleAndAnchor.prototype:IsDefaultScale()
    return uab.db.profile.scale[self.groupname].usedefault
end

function uab.classes.GroupScaleAndAnchor.prototype:IsDefaultPosition()
    return uab.db.profile.position[self.groupname].usedefault
end

function uab.classes.GroupScaleAndAnchor.prototype:UseDefaultScale()
    return {
        type = 'toggle',
        name = "Default scale",
        desc = "Use default scale value for this group",
        get = function()
            return uab.db.profile.scale[self.groupname].usedefault
        end,
        set = function(v)
            if not v then
                if not uab.db.profile.scale[self.groupname].value then
                    uab.db.profile.scale[self.groupname].value = uab.db.profile.scale.default.value
                end
            end
        
            uab.db.profile.scale[self.groupname].usedefault = v
            uab.main:ScaleChanged(self.groupname)
        end,
    }
end

function uab.classes.GroupScaleAndAnchor.prototype:UseDefaultAnchor()
    return {
        type = 'toggle',
        name = "Default anchor",
        desc = "Use default action button anchor information for this group",
        get = function()
            return uab.db.profile.position[self.groupname].usedefault
        end,
        set = function(v)
            if not v then
                if not uab.db.profile.position[self.groupname].point then
                    uab.db.profile.position[self.groupname].point = uab.db.profile.position.default.point
                end
                
                if not uab.db.profile.position[self.groupname].relpoint then
                    uab.db.profile.position[self.groupname].relpoint = uab.db.profile.position.default.relpoint
                end
                
                if not uab.db.profile.position[self.groupname].x then
                    uab.db.profile.position[self.groupname].x = uab.db.profile.position.default.x
                end
                
                if not uab.db.profile.position[self.groupname].y then
                    uab.db.profile.position[self.groupname].y = uab.db.profile.position.default.y
                end
            end
            uab.db.profile.position[self.groupname].usedefault = v
            uab.main:PositionChanged(self.groupname)
        end,
    }
end

function uab.classes.GroupScaleAndAnchor.prototype:GetScale()
    return uab.db.profile.scale[self.groupname].value or uab.db.profile.scale.default.value
end

function uab.classes.GroupScaleAndAnchor.prototype:SetScale(v)
    uab.db.profile.scale[self.groupname].value = v
end

function uab.classes.GroupScaleAndAnchor.prototype:GetPoint()
    return uab.db.profile.position[self.groupname].point or uab.db.profile.position.default.point or "CENTER"
end

function uab.classes.GroupScaleAndAnchor.prototype:SetPoint(v)
    uab.db.profile.position[self.groupname].point = v
end

function uab.classes.GroupScaleAndAnchor.prototype:GetRelPoint()
    return uab.db.profile.position[self.groupname].relpoint or uab.db.profile.position.default.relpoint or "cursor"
end

function uab.classes.GroupScaleAndAnchor.prototype:SetRelPoint(v)
    uab.db.profile.position[self.groupname].relpoint = v
end

function uab.classes.GroupScaleAndAnchor.prototype:GetHorizontal()
    return uab.db.profile.position[self.groupname].x or uab.db.profile.position.default.x
end

function uab.classes.GroupScaleAndAnchor.prototype:SetHorizontal(v)
    uab.db.profile.position[self.groupname].x = v
end

function uab.classes.GroupScaleAndAnchor.prototype:GetVertical()
    return uab.db.profile.position[self.groupname].y or uab.db.profile.position.default.y
end

function uab.classes.GroupScaleAndAnchor.prototype:SetVertical(v)
    uab.db.profile.position[self.groupname].y = v
end

function uab:SetupOffsetOptions()
    uab.GroupIterate(
        function(self, context, name, info)
            local scaleanchor = uab.classes.GroupScaleAndAnchor:new()
            scaleanchor:SetGroup(info.name)
            context.count = context.count + 1

            local options = {
                type = 'group',
                name = info.displayName,
                desc = "Set the position, scale, and behavior, for the action buttons when related to frames in this group",
                order = context.count,
                args = uab.ScaleAndAnchorOptions(scaleanchor)
            }

            options.args.independent = {
                type = 'toggle',
                name = "Independent show/hide",
                desc = "When set, action buttons for this group (regardless of action set) show and hide indepedently from other groups.",
                order = 10,
                get = function()
                    return uab.db.profile.independent[info.name]
                end,
                set = function(v)
                    uab.db.profile.independent[info.name] = v
                    uab.main:SecureHeaderChanged(info.name)
                end,
            }
            
            options.args.stayopen = {
                type = 'text',
                name = "Stay open",
                desc = "Specify the show/hide behavior of the action buttons for this group when clicked.",
                order = 20,
                get = function()
                    if not uab.db.profile.groupstayopen[info.name] then
                        return "Use default"
                    end
                    
                    if uab.db.profile.groupstayopen[info.name].enabled then
                        return "Yes"
                    else
                        return "No"
                    end
                end,
                set = function(v)
                    if v == "Use default" then
                        uab.db.profile.groupstayopen[info.name] = nil
                    elseif v == "Yes" then
                        uab.db.profile.groupstayopen[info.name] = { enabled = true }
                    else
                        uab.db.profile.groupstayopen[info.name] = {}
                    end

                    uab.main:StayOpenChanged(info.name)
                end,
                validate = {
                    "Yes",
                    "No",
                    "Use default",
                },
            }

            options.args.spacing1 = {
                name = " ",
                type = 'header',
                order = 30,
            }

            uab.options.args.lookandfeel.args.groupanchorscale.args[info.name] = options
        end,
        nil,
        { count = 100 })
end

function uab:RefreshActivatorList()
	local order = 10

	local names = {}
	for key, val in pairs(self.db.profile.activators) do
	    if key and key ~= "" then
            table.insert(names, key)
        end
	end

	table.sort(names)

	self.options.args.actionsets.args = {}

    self.options.args.actionsets.args.setup = {
        type = 'execute',
        name = "Setup",
        desc = "Setup action sets and action buttons for each action set",
        func = function()
            UAB_MainFrame:Show()
        end,
		order = 10,
    }
	
    self.options.args.actionsets.args.spacing1 = {
		name = " ",
		type = 'header',
		order = 20,
	}

    self.options.args.actionsets.args.new = {
        type = 'text',
        name = "New",
        desc = "Create a new action set",
        disabled = function() return not uab.main:FindNextAvailableActivation() end,
        usage = "<name>",
        order = 30,
        get = function() return end,
        set = function(name) uab.main:NewActivator(name) end,
        validate = function(name) return not uab.main:ActivatorExists(name) end,
    }

    self.options.args.actionsets.args.remove = {
        type = 'text',
        name = "Remove",
        desc = "Remove an existing action set",
        disabled = function() return not uab.main:AnyActivators() end,
        usage = "<name>",
        order = 40,
        get = function() end,
        set = function(name) uab.main:RemoveActivator(name) end,
        validate = function(name)
			if uab.db.profile.activators[name] then
				return true
			end
        end,
    }

    if # names > 0 then    
        self.options.args.actionsets.args.spacing2 = {
    		name = " ",
    		type = 'header',
    		order = 50,
    	}
    
        order = 100
        for idx = 1, # names, 1 do
            self.options.args.actionsets.args[names[idx]] = self:CreateActionSetOption(names[idx])
            self.options.args.actionsets.args[names[idx]].order = order
            order = order + 1
        end
    end
end

function uab:CreateActionSetOption(name, order)
    local options
    
    options = {
        type = 'group',
        name = name,
        desc = "Mouse activation settings for actions in the "..name.." action set",
        args = {
            active = {
                type = 'toggle',
                name = "Active",
                desc = "Activate this action set",
        		order = 10,
                get = function()
                    return uab.main:GetActivator(name):Enabled()
                end,
                set = function(v)
                    if v and not uab.main:GetActivator(name):Enabled() then
                        uab.main:EnableActivator(name)
                    elseif not v and uab.main:GetActivator(name):Enabled() then
                        uab.main:DisableActivator(name)
                    end
                end,
            },
        
            spacing1 = {
        		name = " ",
        		type = 'header',
        		order = 20,
        	},
	
            independent = {
                type = 'toggle',
                name = "Independent show/hide",
                desc = "When set, action buttons for this action set (regardless of group) show and hide indepedently from other action sets.",
                order = 25,
                get = function()
                    return uab.db.profile.activators[name].independent
                end,
                set = function(v)
                    uab.db.profile.activators[name].independent = v
                    uab.main:SecureHeaderChanged()
                end,
            },
            
            button = {
                type = 'text',
                name = "Button",
                desc = "Select the button to use to activate this action set",
                order = 30,
                get = function()
                    local btn = uab.db.profile.activators[name].button

                    if btn == "LeftButton" then
                        return "left"
                    end

                    if btn == "RightButton" then
                        return "right"
                    end

                    if btn == "MiddleButton" then
                        return "middle"
                    end

                    if btn == "Button4" then
                        return "button4"
                    end

                    return "button5"
                end,
                set = function(button)
                    local btn
                    if button == "left" then
                        btn = "LeftButton"
                    elseif button == "right" then
                        btn = "RightButton"
                    elseif button == "middle" then
                        btn = "MiddleButton"
                    elseif button == "button4" then
                        btn = "Button4"
                    elseif button == "button5" then
                        btn = "Button5"
                    end

                    if btn then
                        uab.main:SetActivatorButton(name, btn)
                    end
                end,

                validate = {"left", "right", "middle", "button4", "button5" }
            },
            keys = {
                type = 'group',
                name = "Keys",
                desc = "Keys that must be pressed for mouse activation",
                order = 40,
                args  = {
                    alt = {
                        type = 'toggle',
                        name = "Alt",
                        desc = "Alt key must be pressed",
						order = 1,
                        get = function()
                            return uab.db.profile.activators[name].prefixalt
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "alt")
                            else
                                uab.main:RemoveActivatorKey(name, "alt")
                            end
                        end,
                    },
                    ctrl = {
                        type = 'toggle',
                        name = "Ctrl",
                        desc = "Ctrl key must be pressed",
						order = 2,
                        get = function()
                            return uab.db.profile.activators[name].prefixctrl
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "ctrl")
                            else
                                uab.main:RemoveActivatorKey(name, "ctrl")
                            end
                        end,
                    },
                    shift = {
                        type = 'toggle',
                        name = "Shift",
                        desc = "Shift key must be pressed",
						order = 3,
                        get = function()
                            return uab.db.profile.activators[name].prefixshift
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "shift")
                            else
                                uab.main:RemoveActivatorKey(name, "shift")
                            end
                        end,
                    },
				    spacing1 = {
						type = 'header',
						name = " ",
						order = 4,
					},
                    clear = {
                        type = 'execute',
                        name = "Clear",
                        desc = "Clear all prefix keys",
						order = 5,
                        func = function()
                            uab.main:ClearActivatorKeys(name)
                        end,
                    },
                },
            },
        },
    }
    
    return options
end

function uab:OnEnable(first)
    if not self.db.profile.position.default.point then
        self.db.profile.position.default.point = "CENTER"
    end
    
    if not self.db.profile.position.default.relpoint then
        self.db.profile.position.default.relpoint = "cursor"
    end
    
    if not self.db.profile.position.default.x then
        self.db.profile.position.default.x = (self.db.profile.default.value and self.db.profile.default.value.x) or 0
    end
    
    if not self.db.profile.position.default.y then
        self.db.profile.position.default.y = (self.db.profile.default.value and self.db.profile.default.value.y) or 0
    end
    
    self.db.profile.position.default.value = nil

	self:EnableModules()
	self.main:Enable()
end

function uab:OnDisable()
	self.main:Disable()
	self:DisableModules()
end

function uab:EnableModules()
	for name,module in pairs(self.modules) do
		self:ToggleModuleActive(module, true)
	end
end

function uab:DisableModules()
	for name,module in pairs(self.modules) do
		self:ToggleModuleActive(module, false)
	end
end

function uab:OnProfileEnable(oldName, oldProfileData)
    --[[
    Profile changed.  We need to reset all the click activators
    based on the new profile.  This could mean renaming some of
    the click activators, disabling others, and changing the set of
    actions for all groups inside each activator.
    --]]
    self:OnDisable()
    self:OnEnable()
end

function uab:OnTooltipUpdate()
	local cat = uab.mixins.tablet:AddCategory("columns", 1)
	cat:AddLine("header", "Unit Action Bars")

	uab.mixins.tablet:SetHint("|cffeda55fClick|r to configure.")
end

function uab:OnClick()
	if not InCombatLockdown() then
        UAB_MainFrame:Show()
    else
        uab.print("Configuration not allowed in combat")
    end
end

function uab.CloneTable(tbl)
	if type(tbl) == "table" then
        local newtbl = {}

        for val, data in pairs(tbl) do
            newtbl[val] = uab.CloneTable(data)
        end
        
        return newtbl
    elseif type(tbl) == "string" then
        return tbl
    elseif type(tbl) == "number" then
        return tbl
    elseif type(tbl) == "boolean" then
        return tbl
    end
end

function uab.DoStartMoving(frame, btn)
	if (btn == "LeftButton") then
		frame:SetUserPlaced(true)
		frame:StartMoving()
		frame.ismoving = true
	end
end
    			
function uab.DoStopMoving(frame)
	if (frame.ismoving) then
		frame:StopMovingOrSizing()
		frame:SetUserPlaced(true)
		frame.ismoving = nil
	end
end

