--[[
Class to manage the actions tab of the config dialog for the add-on.
--]]

uab.classes.ActionsTab = uab.mixins.aceOO.Class()

uab.classes.ActionsTab.activations = {
    { button = "RightButton", prefixshift = true },
    { button = "RightButton", prefixctrl = true },
    { button = "RightButton", prefixalt = true },
    { button = "RightButton", prefixshift = true, prefixctrl = true },
    { button = "RightButton", prefixshift = true, prefixalt = true },
    { button = "RightButton", prefixctrl = true, prefixalt = true },
    { button = "RightButton", prefixshift = true, prefixctrl = true, prefixalt = true },
    
    { button = "LeftButton", prefixshift = true },
    { button = "LeftButton", prefixctrl = true },
    { button = "LeftButton", prefixalt = true },
    { button = "LeftButton", prefixshift = true, prefixctrl = true },
    { button = "LeftButton", prefixshift = true, prefixalt = true },
    { button = "LeftButton", prefixctrl = true, prefixalt = true },
    { button = "LeftButton", prefixshift = true, prefixctrl = true, prefixalt = true },

    { button = "MiddleButton", prefixshift = true },
    { button = "MiddleButton", prefixctrl = true },
    { button = "MiddleButton", prefixalt = true },
    { button = "MiddleButton", prefixshift = true, prefixctrl = true },
    { button = "MiddleButton", prefixshift = true, prefixalt = true },
    { button = "MiddleButton", prefixctrl = true, prefixalt = true },
    { button = "MiddleButton", prefixshift = true, prefixctrl = true, prefixalt = true },

    { button = "Button4", prefixshift = true },
    { button = "Button4", prefixctrl = true },
    { button = "Button4", prefixalt = true },
    { button = "Button4", prefixshift = true, prefixctrl = true },
    { button = "Button4", prefixshift = true, prefixalt = true },
    { button = "Button4", prefixctrl = true, prefixalt = true },
    { button = "Button4", prefixshift = true, prefixctrl = true, prefixalt = true },

    { button = "Button5", prefixshift = true },
    { button = "Button5", prefixctrl = true },
    { button = "Button5", prefixalt = true },
    { button = "Button5", prefixshift = true, prefixctrl = true },
    { button = "Button5", prefixshift = true, prefixalt = true },
    { button = "Button5", prefixctrl = true, prefixalt = true },
    { button = "Button5", prefixshift = true, prefixctrl = true, prefixalt = true },

    { button = "MiddleButton" },
    { button = "Button4" },
    { button = "Button5" },
    { button = "RightButton" },
    { button = "LeftButton" },
}

function uab.classes.ActionsTab.prototype:init()
    uab.classes.ActionsTab.super.prototype.init(self)

    self.frames = {}
    self.frames.controls = UAB_ActionsTabControls
    self.frames.actionbtns = getglobal(self.frames.controls:GetName().."ActionButtons")

    self.frames.actionset = getglobal(self.frames.controls:GetName().."ActionSet")
    self.frames.actionset.uabobj = self

    self.frames.actionsetcopy = getglobal(self.frames.controls:GetName().."ActionSetCopyTo")
    self.frames.actionsetcopy.uabobj = self
    self.frames.actionsetcopy:SetScript("OnClick", function(self, button, down) self.uabobj:CopyActionSet() end)
            
    self.frames.actionsetnew = getglobal(self.frames.controls:GetName().."ActionSetNew")
    self.frames.actionsetnew.uabobj = self
    self.frames.actionsetnew:SetScript("OnClick", function(self, button, down) self.uabobj:NewActionSet() end)
            
    self.frames.actionsetdel = getglobal(self.frames.controls:GetName().."ActionSetDelete")
    self.frames.actionsetdel.uabobj = self
    self.frames.actionsetdel:SetScript("OnClick", function(self, button, down) self.uabobj:DeleteActionSet() end)

    self.frames.setactivator = getglobal(self.frames.controls:GetName().."ActionSetActivator")
    self.frames.setactivator.uabobj = self
    self.frames.setactivator:RegisterForClicks("LeftButtonDown", "RightButtonDown", "MiddleButtonDown", "Button4Down", "Button5Down")
    self.frames.setactivator:SetScript("OnClick", function(self, button, down) self.uabobj:SetActivation(button) end)

    self.frames.activatorlbl = getglobal(self.frames.controls:GetName().."ActivatorLabel")
    
    self.frames.unitgroup = getglobal(self.frames.controls:GetName().."UnitGroup")
    self.frames.unitgroup.uabobj = self

    self.frames.unitgrouplbl = getglobal(self.frames.controls:GetName().."UnitGroupLabel")
    
    self.frames.unitgroupcopy = getglobal(self.frames.controls:GetName().."UnitGroupCopyActions")
    self.frames.unitgroupcopy.uabobj = self
    self.frames.unitgroupcopy:SetScript("OnClick", function(self, button, down) self.uabobj:CopyUnitGroupActions() end)

    self.frames.clear = getglobal(self.frames.actionbtns:GetName().."ActionClear")
    self.frames.clear.uabobj = self
    self.frames.clear:SetScript("OnClick", function(self, button, down) self.uabobj:ClearSelectedAction() end)

    self.frames.userank = getglobal(self.frames.actionbtns:GetName().."UseRank")
    self.frames.userank.uabobj = self

    self.frames.uniteffectlbl = getglobal(self.frames.actionbtns:GetName().."UnitEffectLabel")
    
    self.frames.uniteffect = getglobal(self.frames.actionbtns:GetName().."UnitEffect")
    self.frames.uniteffect.uabobj = self
    
    self.frames.effects = getglobal(self.frames.actionbtns:GetName().."ActionEffects")
    self.frames.effects.uabobj = self

    self.frames.highlight = getglobal(self.frames.effects:GetName().."BorderHighlight")
    self.frames.highlight.uabobj = self
    self.frames.highlight:SetScript("OnClick", function(self, button, down) self.uabobj:UnitEffectOnClick(self, "highlight") end)
    
    self.frames.lowalpha = getglobal(self.frames.effects:GetName().."Alpha50")
    self.frames.lowalpha.uabobj = self
    self.frames.lowalpha:SetScript("OnClick", function(self, button, down) self.uabobj:UnitEffectOnClick(self, "lowalpha") end)
    
    self.frames.blink = getglobal(self.frames.effects:GetName().."Blink")
    self.frames.blink.uabobj = self
    self.frames.blink:SetScript("OnClick", function(self, button, down) self.uabobj:UnitEffectOnClick(self, "blink") end)
    
    self.frames.hide = getglobal(self.frames.effects:GetName().."Hide")
    self.frames.hide.uabobj = self
    self.frames.hide:SetScript("OnClick", function(self, button, down) self.uabobj:UnitEffectOnClick(self, "noalpha") end)
    
    self.frames.notusable = getglobal(self.frames.effects:GetName().."NotUsable")
    self.frames.notusable.uabobj = self
    self.frames.notusable:SetScript("OnClick", function(self, button, down) self.uabobj:UnitEffectOnClick(self, "notusable") end)

    self.frames.actionsetname = UAB_NewActivator
    self.frames.actionsetname.uabobj = self

    self.frames.cga = UAB_CopyGroupActions
    self.frames.cga.uabobj = self

    self.frames.cgacontrols = {}

    local pframe
        
    local frame = CreateFrame("CheckButton", self.frames.cga:GetName().."hostile", self.frames.cga, "OptionsCheckButtonTemplate")
    self.frames.cgacontrols.hostile = frame
    
    frame:SetWidth(24)
    frame:SetHeight(24)
    frame:ClearAllPoints()
    
    frame:SetPoint("TOPLEFT", self.frames.cga, "TOPLEFT", 30, -40)
    getglobal(frame:GetName().."Text"):SetText("Hostile")

	local names = {}
	for key, val in pairs(uab.constants.groupInfo) do
        table.insert(names, key)
	end

	table.sort(names)
    
    pframe = frame

    for idx = 1, # names, 1 do
        local info = uab.constants.groupInfo[names[idx]]
        frame = CreateFrame("CheckButton", self.frames.cga:GetName()..info.name, self.frames.cga, "OptionsCheckButtonTemplate")
        self.frames.cgacontrols[info.name] = frame
        
        frame:SetWidth(24)
        frame:SetHeight(24)
        frame:ClearAllPoints()
        
        if not pframe then
            frame:SetPoint("TOPLEFT", self.frames.cga, "TOPLEFT", 30, -40)
        else
            frame:SetPoint("TOPLEFT", pframe, "BOTTOMLEFT", 0, 0)
        end

        getglobal(frame:GetName().."Text"):SetText(info.displayName)
        pframe = frame
	end

    self.uniteffect = "Default"
    self:CreateActionButtons()
    
    self.unitgroup = "player"
    self:SetupGroups()
    
    self:SetupActivators()
    self:SelectFirstActivator()
    
    self:SetupUseRank()
    
    self:SetupUnitEffects()
    self:SelectFirstUnitEffect()
    
    self:ActivatorsChanged()
    self.frames.controls:Show()
end

function uab.classes.ActionsTab.prototype:SetActivation(button)
    uab.main:SetActivatorButton(self.activator, button)
    uab.main:ClearActivatorKeys(self.activator)

    if ( IsShiftKeyDown() ) then
        uab.main:AddActivatorKey(self.activator, "shift")
    end

    if ( IsAltKeyDown() ) then
        uab.main:AddActivatorKey(self.activator, "alt")
    end

    if ( IsControlKeyDown() ) then
        uab.main:AddActivatorKey(self.activator, "ctrl")
    end

    self:RefreshActivatorCombo()
end

function uab.classes.ActionsTab.prototype:ActivatorsChanged()
    if uab.main:FindNextAvailableActivation() then
        self.frames.actionsetnew:Enable()
    else
        self.frames.actionsetnew:Disable()
    end
    
    self:SetActivator()
end

function uab.classes.ActionsTab.prototype:RefreshActivatorCombo()
    if self.activator then
        local prefix = "";
        local activator = uab.db.profile.activators[self.activator]
    
        if activator.prefixshift then
            prefix = "shift-"..prefix;
        end
        if activator.prefixctrl then
            prefix = "ctrl-"..prefix;
        end
        if activator.prefixalt then
            prefix = "alt-"..prefix;
        end
    
        self.frames.activatorlbl:SetText(prefix..activator.button)
    end
end

function uab.classes.ActionsTab.prototype:ClearSelectedAction()
    self:ClearSelected()
    self.curaction:Clear()
end

function uab.classes.ActionsTab.prototype:CopyActionSet()
    --[[
    Need to present a dialog to get the name of the new action set to
    copy this one to.  This is the same as the NewActionSet operation
    but after entering the name, the contents of the current action
    set are copied to the newly created action set.
    --]]
    self:NewActionSet(self.activator)
end
            
function uab.classes.ActionsTab.prototype:NewActionSet(copyfrom)
    --[[
    First, modify our state so that we think there is no action set
    selected.  This prevents changes to the current action set until
    this dialog is closed.  In addition, disable (don't hide) the
    "New" button, to prevent it from being clicked as well.
    
    Present a dialog to get the name of the new action set.  After
    getting that name (user clicks OK), the new action set is created
    and then made the current action set.
    --]]
    
    self.actionsetnewinfo = {}
    
    self.actionsetnewinfo.activator = self.activator
    self.actionsetnewinfo.unitgroup = self.unitgroup
    self.actionsetnewinfo.copyfrom = copyfrom

    UIDropDownMenu_SetSelectedName(self.frames.actionset, "")
    self.activator = nil
    self:SetActivator()
    self.frames.actionsetnew:Disable()
    
    self.frames.actionsetname:Show()
end

function uab.classes.ActionsTab.prototype:NewActivatorOK()
    local newname = getglobal(self.frames.actionsetname:GetName().."Name"):GetText()
    
    if newname and newname ~= "" then
        self.actionsetnewinfo.completed = true
        uab.main:NewActivator(newname)
        
        if self.actionsetnewinfo.copyfrom then
            --[[
            Duplicate all the actions from the "copyfrom" action set to this
            one.
            --]]
    
            uab.main:CopyActivatorTo(self.actionsetnewinfo.copyfrom, newname)
        end

        self:SetupActivators()
        UIDropDownMenu_SetSelectedName(self.frames.actionset, newname)
        self:SetActivator(newname)
        self:SelectFirstGroup()
    end
    
    self.frames.actionsetname:Hide()
end

function uab.classes.ActionsTab.prototype:NewActivatorCanceled()
    if self.actionsetnewinfo and not self.actionsetnewinfo.completed then
        self.unitgroup = self.actionsetnewinfo.unitgroup
        UIDropDownMenu_SetSelectedName(self.frames.actionset, self.actionsetnewinfo.activator)
        self:SetActivator(self.actionsetnewinfo.activator)
    end

    self.actionsetnewinfo = nil
    getglobal(self.frames.actionsetname:GetName().."Name"):SetText("")
    self.frames.actionsetnew:Enable()
end

function uab.classes.ActionsTab.prototype:DeleteActionSet()
    uab.main:RemoveActivator(self.activator)
    self:SelectFirstActivator()
end
    
function uab.classes.ActionsTab.prototype:CopyUnitGroupActions()
    self.frames.cgacontrols.hostile:Enable()
    self.frames.cgacontrols.hostile:SetChecked(1)
    self.frames.cgacontrols.hostile:Show()
    
    for _, info in pairs(uab.constants.groupInfo) do
        self.frames.cgacontrols[info.name]:Enable()
        self.frames.cgacontrols[info.name]:SetChecked(1)
        self.frames.cgacontrols[info.name]:Show()
    end

    self.frames.cgacontrols[self.unitgroup]:SetChecked(nil)
    self.frames.cgacontrols[self.unitgroup]:Disable()
    self.frames.cgacontrols[self.unitgroup]:Hide()
    
    self.frames.cga:Show()
end

function uab.classes.ActionsTab.prototype:CopyUnitGroupActionsComplete()
    self.frames.cga:Hide()

    local activator = uab.main:GetActivator(self.activator)

    if self.frames.cgacontrols.hostile:GetChecked() then
        --[[
        Copy the actions from the currently selected group of the
        currently selected action set, to this group of that same
        action set.
        --]]
    
        activator:CopyToHostile(activator, self.unitgroup)
    end

    for _, info in pairs(uab.constants.groupInfo) do
        if self.frames.cgacontrols[info.name]:GetChecked() then
            --[[
            Copy the actions from the currently selected group of the
            currently selected action set, to this group of that same
            action set.
            --]]
        
            activator:CopyTo(activator, self.unitgroup, info.name)
        end
    end
end

function uab.classes.ActionsTab.prototype:UnitEffectOnClick(frame, uniteffect)
    self.curaction:UnitEffectOnClick(frame, uniteffect)
end

function uab.classes.ActionsTab.prototype:SetupActivators()
    uab.classes.ActionsTab.InitDropdown = self
    UIDropDownMenu_Initialize(self.frames.actionset,
        function()
            if uab.classes.ActionsTab.InitDropdown then
                uab.classes.ActionsTab.InitDropdown:FillActivators()
            else
                this:GetParent().uabobj:FillActivators()
            end
        end)
	UIDropDownMenu_SetWidth(110, self.frames.actionset)
	UIDropDownMenu_SetButtonWidth(24, self.frames.actionset)
	UIDropDownMenu_JustifyText("LEFT", self.frames.actionset)
    uab.classes.ActionsTab.InitDropdown = nil
end

function uab.classes.ActionsTab.prototype:FillActivators()
	local names = {}
    for key, val in pairs(uab.db.profile.activators) do
        table.insert(names, key)
    end
    
	table.sort(names)

	for idx = 1, # names, 1 do
        local data = {}
        
        data.text = names[idx]
        data.func = uab.DropDownSelect
        data.arg1 = self
        data.arg2 = { func = "SelectActivator", arg1 = names[idx] }

        UIDropDownMenu_AddButton(data)
        if self.activator == names[idx] then
            selected = idx
        end        
	end

    UIDropDownMenu_SetSelectedName(self.frames.actionset, self.activator)
end

function uab.classes.ActionsTab.prototype:SelectActivator(selector, selection)
    UIDropDownMenu_SetSelectedName(self.frames.actionset, selection)
    self:SetActivator(selection)
end

function uab.classes.ActionsTab.prototype:SelectFirstActivator()
	local names = {}
    for key, val in pairs(uab.db.profile.activators) do
        table.insert(names, key)
    end

    if # names then    
    	table.sort(names)
    
        UIDropDownMenu_SetSelectedName(self.frames.actionset, names[1])
        self:SetActivator(names[1])
    else
        UIDropDownMenu_SetSelectedName(self.frames.actionset, "")
        self.activator = nil
        self:SetActivator()
    end
end

function uab.classes.ActionsTab.prototype:SetActivator(selection)
    if selection then
        self.activator = selection
    end
    
    if self.activator then
        if not uab.main:GetActivator(self.activator) then
            self.activator = nil
        end
    end
    
    if not self.activator then
        UIDropDownMenu_SetSelectedName(self.frames.actionset, "")
        
        --[[
        Hide the groups dropdown, the action buttons (and all associated controls)
        and all controls with groups, action buttons, or that operate on the
        current activator.
        --]]
        self.frames.actionbtns:Hide()
        self.frames.setactivator:Hide()
        self.frames.activatorlbl:Hide()
        self.frames.actionsetcopy:Hide()
        self.frames.actionsetnew:Show()
        self.frames.actionsetdel:Hide()
        self.frames.unitgroupcopy:Hide()
        self.frames.unitgroup:Hide()
        self.frames.unitgrouplbl:Hide()
    else
        UIDropDownMenu_SetSelectedName(self.frames.actionset, self.activator)
        
        --[[
        Make sure the action buttons, all groups for groups, action buttons, or that
        operate on the current activator are shown and updated with current action
        set information.
        --]]
        self.frames.actionbtns:Show()
        self.frames.setactivator:Show()
        self.frames.activatorlbl:Show()
        self.frames.actionsetcopy:Show()
        self.frames.actionsetnew:Show()
        self.frames.actionsetdel:Show()
        self.frames.unitgroup:Show()
        self.frames.unitgrouplbl:Show()
        self.frames.unitgroupcopy:Show()
    end
    
    self:ContextChanged()
end

function uab.classes.ActionsTab.prototype:SetupGroups()
    uab.classes.ActionsTab.InitDropdown = self
    UIDropDownMenu_Initialize(self.frames.unitgroup,
        function()
            if uab.classes.ActionsTab.InitDropdown then
                uab.classes.ActionsTab.InitDropdown:FillGroups()
            else
                this:GetParent().uabobj:FillGroups()
            end
        end)
	UIDropDownMenu_SetWidth(110, self.frames.unitgroup)
	UIDropDownMenu_SetButtonWidth(24, self.frames.unitgroup)
	UIDropDownMenu_JustifyText("LEFT", self.frames.unitgroup)
    uab.classes.ActionsTab.InitDropdown = nil
end

function uab.classes.ActionsTab.prototype:GetGroups()
    local index = 1
    local selected = nil

    local options = {}

    table.insert(options, {
        text = "Hostile",
        func = uab.DropDownSelect,
        arg1 = self,
        arg2 = { func = "SelectUnitGroup", arg1 = "hostile" }})

	local names = {}
	for key, val in pairs(uab.constants.groupInfo) do
        table.insert(names, key)
	end

	table.sort(names)

    for idx = 1, # names, 1 do
        local info = uab.constants.groupInfo[names[idx]]    
        table.insert(options, {
            text = info.displayName,
            func = uab.DropDownSelect,
            arg1 = self,
            arg2 = { func = "SelectUnitGroup", arg1 = info.name }})
    end

    return options
end

function uab.classes.ActionsTab.prototype:FillGroups()
    local selected = nil

    local options = self:GetGroups()

    for index, data in pairs(options) do
        UIDropDownMenu_AddButton(data)
        if data.arg2.arg1 == self.unitgroup then
            selected = data.text
        end
    end

    UIDropDownMenu_SetSelectedName(self.frames.unitgroup, selected)
end

function uab.classes.ActionsTab.prototype:SelectUnitGroup(selector, selection)
    local selected = nil
    local options = self:GetGroups()

    for _, data in pairs(options) do
        if data.arg2.arg1 == selection then
            selected = data.text
        end
    end

    self.unitgroup = selection
    UIDropDownMenu_SetSelectedName(self.frames.unitgroup, selected)
    self:ContextChanged()
end

function uab.classes.ActionsTab.prototype:SelectFirstGroup()
    UIDropDownMenu_SetSelectedName(self.frames.unitgroup, "Player")
    self:ContextChanged()
end    

function uab.classes.ActionsTab.prototype:SetupUseRank()
    uab.classes.ActionsTab.InitDropdown = self
    UIDropDownMenu_Initialize(self.frames.userank,
        function()
            if uab.classes.ActionsTab.InitDropdown then
                uab.classes.ActionsTab.InitDropdown:FillUseRank()
            else
                this:GetParent().uabobj:FillUseRank()
            end
        end)
	UIDropDownMenu_SetWidth(110, self.frames.userank)
	UIDropDownMenu_SetButtonWidth(24, self.frames.userank)
	UIDropDownMenu_JustifyText("LEFT", self.frames.userank)
    uab.classes.ActionsTab.InitDropdown = nil
end

function uab.classes.ActionsTab.prototype:FillUseRank()
    if self.curaction then
        self.curaction:FillUseRank()
    end
end
	
function uab.classes.ActionsTab.prototype:SetupUnitEffects()
    uab.classes.ActionsTab.InitDropdown = self
    UIDropDownMenu_Initialize(self.frames.uniteffect,
        function()
            if uab.classes.ActionsTab.InitDropdown then
                uab.classes.ActionsTab.InitDropdown:FillUnitEffects()
            else
                this:GetParent().uabobj:FillUnitEffects()
            end
        end)
	UIDropDownMenu_SetWidth(150, self.frames.uniteffect)
	UIDropDownMenu_SetButtonWidth(24, self.frames.uniteffect)
	UIDropDownMenu_JustifyText("LEFT", self.frames.uniteffect)
    uab.classes.ActionsTab.InitDropdown = nil
end

function uab.classes.ActionsTab.prototype:GetUnitEffects()
    local index = 1
    local selected = nil

    local options = {}

	local uniteffects = uabUnitStatus:GetAllUnitStatus()
	local sorted = {}

	for name, _ in pairs(uniteffects) do
		table.insert(sorted, name)
	end
	
	table.sort(sorted)

	for idx, name in pairs(sorted) do
		table.insert(options, { text = name,
								func = uab.DropDownSelect,
								arg1 = self,
								arg2 = { func = "SelectUnitEffect", arg1 = name } })
	end		

    return options
end

function uab.classes.ActionsTab.prototype:FillUnitEffects()
    local index = 1
    local selected = nil

    local options = self:GetUnitEffects()

    for index, data in pairs(options) do
        UIDropDownMenu_AddButton(data)
        if self.uniteffect == data.arg2.arg1 then
            selected = index
        end
    end

    UIDropDownMenu_SetSelectedID(self.frames.uniteffect, selected)
end

function uab.classes.ActionsTab.prototype:SelectUnitEffect(selector, selection)
    UIDropDownMenu_SetSelectedID(self.frames.uniteffect, selector:GetID())
    self.uniteffect = selection
    self:EffectChanged()
end

function uab.classes.ActionsTab.prototype:SelectFirstUnitEffect()
    local index = 1
    local selected = nil

    local options = self:GetUnitEffects()

    for index, data in pairs(options) do
        if data.arg2.arg1 == "Default" then
            selected = index
        end
    end

    UIDropDownMenu_SetSelectedID(self.frames.uniteffect, selected)
    self.uniteffect = "Default"
end    

function uab.classes.ActionsTab.prototype:CreateActionButtons()
    self.actionbtns = {}

    for idx = 1, 24, 1 do
        self:CreateActionButton(idx)
    end    
end

function uab.classes.ActionsTab.prototype:CreateActionButton(idx)
    local relinfo = {}

    relinfo.point = "TOPLEFT"

    if idx == 1 then
        relinfo.relpoint = "TOPLEFT"
        relinfo.relto = self.frames.actionbtns
        relinfo.x = 30
        relinfo.y = -38
    elseif idx == 7 or idx == 13 or idx == 19 then
        relinfo.relpoint = "BOTTOMLEFT"
        relinfo.relto = self.actionbtns[idx-6]:GetFrame()
        relinfo.x = 0
        relinfo.y = -5
    else
        relinfo.relpoint = "TOPRIGHT"
        relinfo.relto = self.actionbtns[idx-1]:GetFrame()
        relinfo.x = 5
        relinfo.y = 0
    end

    self.actionbtns[idx] = uab.classes.CfgActionButton:new(self, self:ActionInfo(idx), idx, relinfo)
    self.actionbtns[idx]:SetEffect(self.uniteffect)
end

function uab.classes.ActionsTab.prototype:GetActionsFrame()
    return self.frames.actionbtns
end

function uab.classes.ActionsTab.prototype:ClearSelected()        
    for idx = 1, 24, 1 do
        self.actionbtns[idx]:SetCurrent(nil)
    end

    self.frames.clear:Hide()
    self.frames.userank:Hide()
    self.frames.uniteffectlbl:Hide()
    self.frames.uniteffect:Hide()
    self.frames.effects:Hide()
end

function uab.classes.ActionsTab.prototype:SetActionData(actionbtn)
    if self.activator and self.unitgroup then
        uab.main:GetActivator(self.activator):SetAction(self.unitgroup, actionbtn:GetNumber(), actionbtn:GetActionData())

        uab.main:ActionsChanged(uab.main:GetActivator(self.activator))
    end
end

function uab.classes.ActionsTab.prototype:SelectAction(actionbtn)
    self:ClearSelected()
    self.curaction = actionbtn
    actionbtn:SetCurrent(true)
end

function uab.classes.ActionsTab.prototype:ContextChanged()
    self:ClearSelected()
    for idx = 1, 24, 1 do
        self.actionbtns[idx]:SetInfo(self:ActionInfo(idx))
    end
    self:RefreshActivatorCombo()
end

function uab.classes.ActionsTab.prototype:EffectChanged()
    for idx = 1, 24, 1 do
        self.actionbtns[idx]:SetEffect(self.uniteffect)
    end
    self.curaction:SetCurrent(true)
end

function uab.classes.ActionsTab.prototype:ActionInfo(actionid)
    if self.activator then
        local activator = uab.db.profile.activators[self.activator]
        local group = activator.groups[self.unitgroup]
    
        if not group.actions then
            group.actions = {}
        end

        if not group.actions[actionid] then
            group.actions[actionid] = {}
        end
        
        return group.actions[actionid]
    end
end

